#include "RKData.h"

CRKData::CRKData()
{
}

CRKData::~CRKData()
{
	delete [] y;
	delete [] yn;
	delete [] k1;
	delete [] k2;
	delete [] k3;
	delete [] k4;
}
double* CRKData::initState(int ndim, double dx)
{
	n = ndim;
	h = dx;
	y  =  new double[n];
	yn =  new double[n];
	k1 =  new double[n];
	k2 =  new double[n];
	k3 =  new double[n];
	k4 =  new double[n];

	return y;
}

void CRKData::rk4(double xd)
{
	int i;

	x = xd;
    rhs(x, y, k1);

    for(i=0;i<n;i++) yn[i] = y[i] + h*k1[i]/2;
    rhs(x+h/2,yn, k2);

    for(i=0;i<n;i++) yn[i] = y[i] + h*k2[i]/2;
    rhs(x+h/2,yn, k3); 

    for(i=0;i<n;i++) yn[i] = y[i] + h*k3[i];
    rhs(x+h, yn, k4);

    for(i=0;i<n;i++) y[i] += h*(k1[i] + 2*k2[i] + 2*k3[i] + k4[i])/6;
}
